"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_2 = require("@testing-library/react");
const user_event_1 = __importDefault(require("@testing-library/user-event"));
const cloneDeep_1 = __importDefault(require("lodash/cloneDeep"));
const compositions = __importStar(require("./use-async-object-manager.composition"));
const demo_data_1 = require("./demo-data");
const test_utils_1 = require("./test-utils");
describe('Use async request hook', () => {
    describe('Compositions', () => {
        Object.entries(compositions).forEach(([name, Composition]) => {
            test(name, () => __awaiter(void 0, void 0, void 0, function* () {
                (0, react_2.render)(react_1.default.createElement(Composition, null));
                // @ts-ignore
                if (Composition.waitForReady)
                    yield Composition.waitForReady();
            }));
        });
    });
    describe('loading data', () => {
        test('should load data and show in composition', () => __awaiter(void 0, void 0, void 0, function* () {
            (0, react_2.render)(react_1.default.createElement(compositions.AsyncTestLoadOnInit, null));
            yield react_2.screen.getByText('loading data');
            yield react_2.screen.findByText('Loaded data');
            yield react_2.screen.findAllByText((0, test_utils_1.JSONStringifySorted)(demo_data_1.demoLoadedData));
        }));
        test('should load data when clicking reload button', () => __awaiter(void 0, void 0, void 0, function* () {
            (0, react_2.render)(react_1.default.createElement(compositions.AsyncTest, null));
            const loadBtn = react_2.screen.getByRole('button', { name: /Reload data/ });
            yield user_event_1.default.click(loadBtn);
            yield react_2.screen.getByText('loading data');
            yield react_2.screen.findByText('Loaded data');
            yield react_2.screen.findAllByText((0, test_utils_1.JSONStringifySorted)(demo_data_1.demoLoadedData));
        }));
        test('should increase call count clicking reload button', () => __awaiter(void 0, void 0, void 0, function* () {
            (0, react_2.render)(react_1.default.createElement(compositions.AsyncTest, null));
            expect(parseInt(react_2.screen.getByTestId('callcount').textContent || '0')).toEqual(0);
            const loadBtn = react_2.screen.getByRole('button', { name: /Reload data/ });
            yield user_event_1.default.click(loadBtn);
            yield react_2.screen.getByText('loading data');
            yield react_2.screen.findByText('Loaded data');
            yield react_2.screen.findAllByText((0, test_utils_1.JSONStringifySorted)(demo_data_1.demoLoadedData));
            expect(parseInt(react_2.screen.getByTestId('callcount').textContent || '0')).toEqual(1);
        }));
        test('should be able to reload the doc', () => __awaiter(void 0, void 0, void 0, function* () {
            (0, react_2.render)(react_1.default.createElement(compositions.AsyncTestLoadOnInit, null));
            expect(parseInt(react_2.screen.getByTestId('callcount').textContent || '0')).toEqual(1);
            const loadBtn = react_2.screen.getByRole('button', { name: /Reload data/ });
            yield react_2.screen.getByText('loading data');
            yield react_2.screen.findByText('Loaded data');
            yield react_2.screen.findAllByText((0, test_utils_1.JSONStringifySorted)(demo_data_1.demoLoadedData));
            const dbOverrideInput = react_2.screen.getByLabelText('Goodbye Input Db');
            yield user_event_1.default.click(dbOverrideInput);
            yield user_event_1.default.clear(dbOverrideInput);
            yield (0, react_2.waitFor)(() => expect(dbOverrideInput.value).toEqual(''));
            const altValue = '1';
            yield user_event_1.default.keyboard(altValue);
            yield (0, react_2.waitFor)(() => expect(parseInt(react_2.screen.getByTestId('callcount').textContent || '0')).toEqual(2));
            expect(react_2.screen.queryByText(`"${altValue}"`, { exact: false })).not.toBeInTheDocument();
            yield user_event_1.default.click(loadBtn);
            yield (0, react_2.waitFor)(() => expect(parseInt(react_2.screen.getByTestId('callcount').textContent || '0')).toEqual(3));
            yield react_2.screen.findByText(`"${altValue}"`, { exact: false });
            yield (0, react_2.waitFor)(() => expect(react_2.screen.getByTestId('loadedData').textContent).toContain(altValue));
            expect(react_2.screen.getByTestId('loadedData').textContent).toContain(altValue);
        }));
        test.todo('should show loading message');
    });
    describe('Creating a new document', () => {
        test('should be able to save a new document', () => __awaiter(void 0, void 0, void 0, function* () {
            (0, react_2.render)(react_1.default.createElement(compositions.AsyncTestNewObject, null));
            yield compositions.AsyncTest.waitForReady();
            const formInputEl = react_2.screen.getByLabelText('Goodbye Input');
            yield user_event_1.default.clear(formInputEl);
            const newVal = 'New Value';
            yield user_event_1.default.type(formInputEl, newVal);
            const newData = Object.assign(Object.assign({}, demo_data_1.inputAdditionalData), { goodbye: newVal, uid: expect.any(String) });
            yield (0, react_2.waitFor)(() => expect(react_2.screen.getByTestId('data').textContent).toContain(newVal));
            const newDataRead = JSON.parse(react_2.screen.getByTestId('data').textContent || '{}');
            expect(newDataRead).toEqual(newData);
            const dbData = react_2.screen.getByTestId('dbData').textContent;
            expect(dbData).toEqual(JSON.stringify(demo_data_1.demoDbData));
        }));
    });
    describe('Updating doc', () => {
        test('should call save callback on successful submit', () => __awaiter(void 0, void 0, void 0, function* () {
            (0, react_2.render)(react_1.default.createElement(compositions.AsyncTest, null));
            yield compositions.AsyncTest.waitForReady();
            const loadBtn = react_2.screen.getByRole('button', { name: /Reload data/ });
            yield user_event_1.default.click(loadBtn);
            yield react_2.screen.findByText('Loaded data');
            const formInputEl = react_2.screen.getByLabelText('Goodbye Input');
            yield user_event_1.default.clear(formInputEl);
            const newVal = 'New Value';
            yield user_event_1.default.type(formInputEl, newVal);
            const newData = Object.assign(Object.assign(Object.assign({}, demo_data_1.demoLoadedData), demo_data_1.inputAdditionalData), { goodbye: newVal });
            const saveBtn = react_2.screen.getByRole('button', { name: /Save/ });
            yield user_event_1.default.click(saveBtn);
            const savedCallbackResponse = yield react_2.screen.findByTestId('onSavedCallbackResponse');
            expect(JSON.parse(savedCallbackResponse.textContent || '{}')).toEqual([
                demo_data_1.demoLoadedData.uid,
                { ok: true },
                newData,
            ]);
        }));
        test('should not call save callback on failed submit', () => __awaiter(void 0, void 0, void 0, function* () {
            const okVal = 'OK';
            const invalidVal = 'ERROR';
            (0, react_2.render)(react_1.default.createElement(compositions.AsyncTest, null));
            yield compositions.AsyncTest.waitForReady();
            const loadBtn = react_2.screen.getByRole('button', { name: /Reload data/ });
            yield user_event_1.default.click(loadBtn);
            yield react_2.screen.findByText('Loaded data');
            const saveBtn = react_2.screen.getByRole('button', { name: /Save/ });
            const formInputEl = react_2.screen.getByLabelText('Goodbye Input');
            yield user_event_1.default.clear(formInputEl);
            yield user_event_1.default.type(formInputEl, invalidVal);
            yield user_event_1.default.click(saveBtn);
            const errorCallbackResponse = yield react_2.screen.findByTestId('saveErrorCallbackResponse');
            expect(errorCallbackResponse.textContent).toEqual('You asked for an error?');
            expect(react_2.screen.queryByTestId('onSavedCallbackResponse')).not.toBeInTheDocument();
            yield user_event_1.default.clear(formInputEl);
            yield user_event_1.default.type(formInputEl, okVal);
            yield user_event_1.default.click(saveBtn);
            yield react_2.screen.findByTestId('onSavedCallbackResponse');
            expect(react_2.screen.queryByText('You asked for an error?')).not.toBeInTheDocument();
            yield user_event_1.default.clear(formInputEl);
            yield user_event_1.default.type(formInputEl, invalidVal);
            yield user_event_1.default.click(saveBtn);
            yield react_2.screen.findByText('You asked for an error?');
            expect(react_2.screen.queryByTestId('onSavedCallbackResponse')).not.toBeInTheDocument();
        }));
        test('should change local data when editing input', () => __awaiter(void 0, void 0, void 0, function* () {
            (0, react_2.render)(react_1.default.createElement(compositions.AsyncTest, null));
            yield compositions.AsyncTest.waitForReady();
            const loadBtn = react_2.screen.getByRole('button', { name: /Reload data/ });
            yield user_event_1.default.click(loadBtn);
            yield react_2.screen.findByText('Loaded data');
            const formInputEl = react_2.screen.getByLabelText('Goodbye Input');
            yield user_event_1.default.clear(formInputEl);
            const newVal = 'New Value';
            yield user_event_1.default.type(formInputEl, newVal);
            const newData = Object.assign(Object.assign(Object.assign({}, demo_data_1.demoLoadedData), demo_data_1.inputAdditionalData), { goodbye: newVal });
            yield react_2.screen.findAllByText((0, test_utils_1.JSONStringifySorted)(newData));
            const dbData = react_2.screen.getByTestId('dbData').textContent;
            expect(dbData).toEqual(JSON.stringify(demo_data_1.demoDbData));
        }));
        test('should change database data when editing input and saving', () => __awaiter(void 0, void 0, void 0, function* () {
            (0, react_2.render)(react_1.default.createElement(compositions.AsyncTestLoadOnInit, null));
            yield compositions.AsyncTestLoadOnInit.waitForReady();
            const formInputEl = react_2.screen.getByLabelText('Goodbye Input');
            yield user_event_1.default.clear(formInputEl);
            const newVal = 'New Value';
            yield user_event_1.default.type(formInputEl, newVal);
            const newData = Object.assign(Object.assign(Object.assign({}, demo_data_1.demoLoadedData), demo_data_1.inputAdditionalData), { goodbye: newVal });
            yield react_2.screen.findAllByText((0, test_utils_1.JSONStringifySorted)(newData));
            const saveBtn = react_2.screen.getByRole('button', { name: /Save/ });
            yield user_event_1.default.click(saveBtn);
            const expectedDbData = Object.assign({}, demo_data_1.demoDbData);
            expectedDbData.demoCollection.abc = Object.assign(Object.assign(Object.assign({}, expectedDbData.demoCollection.abc), demo_data_1.inputAdditionalData), { goodbye: newVal });
            yield (0, react_2.waitFor)(() => expect(react_2.screen.getByTestId('dbData').textContent).toEqual(JSON.stringify(expectedDbData)));
            const dbData = react_2.screen.getByTestId('dbData').textContent;
            expect(dbData).toEqual(JSON.stringify(expectedDbData));
        }));
        test('should change database data when editing input and saving', () => __awaiter(void 0, void 0, void 0, function* () {
            (0, react_2.render)(react_1.default.createElement(compositions.AsyncTestLoadOnInit, null));
            yield compositions.AsyncTestLoadOnInit.waitForReady();
            const formInputEl = react_2.screen.getByLabelText('Goodbye Input');
            yield user_event_1.default.clear(formInputEl);
            const newVal = 'New Value';
            yield user_event_1.default.type(formInputEl, newVal);
            const newData = Object.assign(Object.assign(Object.assign({}, demo_data_1.demoLoadedData), demo_data_1.inputAdditionalData), { goodbye: newVal });
            yield react_2.screen.findAllByText((0, test_utils_1.JSONStringifySorted)(newData));
            const saveBtn = react_2.screen.getByRole('button', { name: /Save/ });
            yield user_event_1.default.click(saveBtn);
            const expectedDbData = Object.assign({}, demo_data_1.demoDbData);
            expectedDbData.demoCollection.abc = Object.assign(Object.assign(Object.assign({}, expectedDbData.demoCollection.abc), demo_data_1.inputAdditionalData), { goodbye: newVal });
            yield (0, react_2.waitFor)(() => expect(react_2.screen.getByTestId('dbData').textContent).toEqual(JSON.stringify(expectedDbData)));
            const dbData = react_2.screen.getByTestId('dbData').textContent;
            expect(dbData).toEqual(JSON.stringify(expectedDbData));
        }));
        test('should save data when saveAllOnSave is true', () => __awaiter(void 0, void 0, void 0, function* () {
            // TODO: This is difficult to test with current test setup
            // render(<compositions.AsyncTestSaveAll />);
            // await compositions.AsyncTestLoadOnInit.waitForReady();
            // const formInputEl = screen.getByLabelText('Goodbye Input');
            // await UserEvent.clear(formInputEl);
            // const newVal = 'New Value';
            // await UserEvent.type(formInputEl, newVal);
            // const newData = {
            //   ...demoLoadedData,
            //   ...inputAdditionalData,
            //   goodbye: newVal,
            // };
            // await screen.findAllByText(JSONStringifySorted(newData));
            // const saveBtn = screen.getByRole('button', { name: /Save/ });
            // await UserEvent.click(saveBtn);
            // const expectedDbData = { ...demoDbData };
            // expectedDbData.demoCollection.abc = {
            //   ...expectedDbData.demoCollection.abc,
            //   ...inputAdditionalData,
            //   goodbye: newVal,
            // };
            // await waitFor(() =>
            //   expect(screen.getByTestId('dbData').textContent).toEqual(
            //     JSON.stringify(expectedDbData)
            //   )
            // );
            // const dbData = screen.getByTestId('dbData').textContent;
            // expect(dbData).toEqual(JSON.stringify(expectedDbData));
        }));
        test.todo('should be able to update an array value');
        test('should handle errors when saving', () => __awaiter(void 0, void 0, void 0, function* () {
            (0, react_2.render)(react_1.default.createElement(compositions.AsyncTestLoadOnInit, null));
            yield compositions.AsyncTestLoadOnInit.waitForReady();
            const formInputEl = react_2.screen.getByLabelText('Goodbye Input');
            yield user_event_1.default.clear(formInputEl);
            const newVal = 'ERROR'; // The mock post function will pick this up and throw an error
            yield user_event_1.default.type(formInputEl, newVal);
            const newData = Object.assign(Object.assign(Object.assign({}, demo_data_1.demoLoadedData), demo_data_1.inputAdditionalData), { goodbye: newVal });
            yield react_2.screen.findAllByText((0, test_utils_1.JSONStringifySorted)(newData));
            const saveBtn = react_2.screen.getByRole('button', { name: /Save/ });
            yield user_event_1.default.click(saveBtn);
            const expectedDbData = (0, cloneDeep_1.default)(demo_data_1.demoDbData);
            expectedDbData.demoCollection.abc = Object.assign(Object.assign(Object.assign({}, expectedDbData.demoCollection.abc), demo_data_1.inputAdditionalData), { goodbye: newVal });
            yield (0, react_2.waitFor)(() => expect(react_2.screen.getByTestId('saveError').textContent).toEqual('You asked for an error?'));
            const dbData = react_2.screen.getByTestId('dbData').textContent;
            expect(dbData).toEqual(JSON.stringify(demo_data_1.demoDbData));
        }));
    });
});
//# sourceMappingURL=use-async-object-manager.test.js.map